//====================================================
// Pixel Blur
//====================================================
// By EVOLVED
// www.evolved-software.com
//====================================================

//--------------
// tweaks
//--------------
   float2 ViewVec;
   float PixelBlur=2.6f;

//--------------
// Textures
//--------------
   texture RenderColorTX <string Name = " ";>;
   sampler RenderColor=sampler_state 
      {
	Texture=<RenderColorTX>;
   	ADDRESSU=CLAMP;
   	ADDRESSV=CLAMP;
   	ADDRESSW=CLAMP;
      };
   texture velocityTX <string Name=" ";>;
   sampler velocity=sampler_state 
      {
	Texture=<velocityTX>;
     	ADDRESSU=CLAMP;
        ADDRESSV=CLAMP;
        ADDRESSW=CLAMP;
      };

//--------------
// structs 
//--------------
   struct InPut
     {
 	float4 Pos:POSITION;
     };
   struct OutPut
     {
	float4 OPos:POSITION; 
 	float2 Tex:TEXCOORD0;
     };

//--------------
// vertex shader
//--------------
   OutPut VS(InPut IN) 
     {
 	OutPut OUT;
	OUT.OPos=IN.Pos; 
 	OUT.Tex=((float2(IN.Pos.x,-IN.Pos.y)+1.0)*0.5)+ViewVec;
	return OUT;
    }

//--------------
// pixel shader
//--------------
   float4 PS(OutPut IN) : COLOR
     {
	float2 pixelVelocity=tex2D(velocity,IN.Tex)*PixelBlur;
	pixelVelocity.x=-pixelVelocity.x;
 	float3 MotionBlur=0;
	for (float i=0;i<10;i++)
	{       
	 MotionBlur +=tex2D(RenderColor,IN.Tex+(pixelVelocity*(i/10)));
	}
	return float4(MotionBlur/10,1);
     }

//--------------
// techniques   
//--------------
    technique MotionBlur
      {
 	pass p1
      {		
 	VertexShader = compile vs_2_0 VS(); 
 	PixelShader  = compile ps_2_0 PS(); 	
      }
      }
