string Description = "PSX";

float2 ViewSize : ViewSize;

float palette = 32;

//scene image
texture frame : RENDERCOLORTARGET
< 
	string ResourceName = "";
	float2 ViewportRatio = { 1.0, 1.0 };
	//int width = 320;
	//int height = 240;
>;

sampler2D frameSamp = sampler_state {
    Texture = < frame >;
    MinFilter = point; MagFilter = point; MipFilter = point;
    AddressU = Clamp; AddressV = Clamp;
};


//downsample image
texture Downsample1Img : RENDERCOLORTARGET 
< 
	string ResourceName = ""; 
	//float2 ViewportRatio = { 1.0, 1.0 };
	int width = 320;
	int height = 240;
>;

sampler2D Downsample1Samp = sampler_state {
    Texture = < Downsample1Img >;
    MinFilter = point; MagFilter = point; MipFilter = point;
    AddressU = Clamp; AddressV = Clamp;
};

struct input 
{
	float4 pos : POSITION;
	float2 uv : TEXCOORD0;
};
 
struct output {

	float4 pos: POSITION;
	float2 uv: TEXCOORD0;

};

output VS( input IN ) 
{
	output OUT;

	//quad needs to be shifted by half a pixel.
    //Go here for more info: http://www.sjbrown.co.uk/?article=directx_texels
    
	float4 oPos = float4( IN.pos.xy + float2( -1.0f/ViewSize.x, 1.0f/ViewSize.y ),0.0,1.0 );
	OUT.pos = oPos;

	float2 uv = (IN.pos.xy + 1.0) / 2.0;
	uv.y = 1 - uv.y; 
	OUT.uv = uv;
	
	return OUT;	
}

float4 PSDownsample( output IN, uniform sampler2D srcTex ) : COLOR
{
    float4 color = tex2D(srcTex,IN.uv);

    return color;
}

float4 PSPalette( output IN, uniform sampler2D srcTex ) : COLOR
{
    float4 color = tex2D(srcTex,IN.uv);
    color = floor(color*palette)/palette;

    return color;
}

technique Palette
<
	//the initial texture we want DarkBASIC Professional to place the scene
	string RenderColorTarget = "frame";
>
{
	pass downsample
	<
		//use a blank render target to draw to the screen
		string RenderColorTarget = "Downsample1Img";
	>
	{
		ZEnable = False;
		VertexShader = compile vs_1_1 VS();
		PixelShader = compile ps_2_0 PSDownsample( frameSamp );
	}
	
	pass Palette
	<
		//use a blank render target to draw to the screen
		string RenderColorTarget = "";
	>
	{
		ZEnable = False;
		VertexShader = compile vs_1_1 VS();
		PixelShader = compile ps_2_0 PSPalette( Downsample1Samp );
	}
}
